## API Report File for "@builder.io/qwik"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import type { QwikManifest } from '@builder.io/qwik/optimizer';
import type { SnapshotResult } from '@builder.io/qwik';
import type { StreamWriter } from '@builder.io/qwik';
import type { SymbolMapper } from '@builder.io/qwik/optimizer';
import type { SymbolMapperFn } from '@builder.io/qwik/optimizer';

// @public
export function getQwikLoaderScript(opts?: {
    events?: string[];
    debug?: boolean;
}): string;

// @public (undocumented)
export interface InOrderAuto {
    // (undocumented)
    maximunChunk?: number;
    // (undocumented)
    maximunInitialChunk?: number;
    // (undocumented)
    strategy: 'auto';
}

// @public (undocumented)
export interface InOrderDisabled {
    // (undocumented)
    strategy: 'disabled';
}

// Warning: (ae-forgotten-export) The symbol "InOrderDirect" needs to be exported by the entry point index.d.ts
//
// @public (undocumented)
export type InOrderStreaming = InOrderAuto | InOrderDisabled | InOrderDirect;

// @public (undocumented)
export interface PrefetchImplementation {
    linkInsert?: 'js-append' | 'html-append' | null;
    linkRel?: 'prefetch' | 'preload' | 'modulepreload' | null;
    prefetchEvent?: 'always' | null;
    workerFetchInsert?: 'always' | 'no-link-support' | null;
}

// @public (undocumented)
export interface PrefetchResource {
    // (undocumented)
    imports: PrefetchResource[];
    // (undocumented)
    url: string;
}

// @public (undocumented)
export interface PrefetchStrategy {
    // (undocumented)
    implementation?: PrefetchImplementation;
    // (undocumented)
    symbolsToPrefetch?: SymbolsToPrefetch;
}

// @public (undocumented)
export interface QwikLoaderOptions {
    // (undocumented)
    events?: string[];
    // (undocumented)
    include?: 'always' | 'never' | 'auto';
    // (undocumented)
    position?: 'top' | 'bottom';
}

// @public (undocumented)
export type Render = RenderToString | RenderToStream;

// @public (undocumented)
export interface RenderOptions extends SerializeDocumentOptions {
    base?: string | ((options: RenderOptions) => string);
    // (undocumented)
    containerAttributes?: Record<string, string>;
    containerTagName?: string;
    locale?: string | ((options: RenderOptions) => string);
    // (undocumented)
    prefetchStrategy?: PrefetchStrategy | null;
    qwikLoader?: QwikLoaderOptions;
    // (undocumented)
    serverData?: Record<string, any>;
    snapshot?: boolean;
}

// @public (undocumented)
export interface RenderResult {
    // (undocumented)
    isStatic: boolean;
    // (undocumented)
    manifest?: QwikManifest;
    // (undocumented)
    prefetchResources: PrefetchResource[];
    // (undocumented)
    snapshotResult: SnapshotResult | undefined;
    // @internal
    _symbols?: string[];
}

// @public (undocumented)
export type RenderToStream = (opts: RenderToStreamOptions) => Promise<RenderToStreamResult>;

// @public
export function renderToStream(rootNode: any, opts: RenderToStreamOptions): Promise<RenderToStreamResult>;

// @public (undocumented)
export interface RenderToStreamOptions extends RenderOptions {
    // (undocumented)
    stream: StreamWriter;
    // (undocumented)
    streaming?: StreamingOptions;
}

// @public (undocumented)
export interface RenderToStreamResult extends RenderResult {
    // (undocumented)
    flushes: number;
    // (undocumented)
    size: number;
    // (undocumented)
    timing: {
        firstFlush: number;
        render: number;
        snapshot: number;
    };
}

// @public (undocumented)
export type RenderToString = (opts: RenderToStringOptions) => Promise<RenderToStringResult>;

// @public
export function renderToString(rootNode: any, opts?: RenderToStringOptions): Promise<RenderToStringResult>;

// @public (undocumented)
export interface RenderToStringOptions extends RenderOptions {
}

// @public (undocumented)
export interface RenderToStringResult extends RenderResult {
    // (undocumented)
    html: string;
    // (undocumented)
    timing: {
        render: number;
        snapshot: number;
    };
}

// Warning: (ae-forgotten-export) The symbol "ResolvedManifest" needs to be exported by the entry point index.d.ts
//
// @public (undocumented)
export function resolveManifest(manifest: QwikManifest | ResolvedManifest | undefined): ResolvedManifest | undefined;

// @public (undocumented)
export interface SerializeDocumentOptions {
    // (undocumented)
    debug?: boolean;
    // (undocumented)
    manifest?: QwikManifest | ResolvedManifest;
    // (undocumented)
    symbolMapper?: SymbolMapperFn;
}

// @public (undocumented)
export function setServerPlatform(manifest: QwikManifest | ResolvedManifest | undefined): Promise<void>;

// @public (undocumented)
export interface StreamingOptions {
    // (undocumented)
    inOrder?: InOrderStreaming;
}

// @public
export type SymbolsToPrefetch = 'auto' | ((opts: {
    manifest: QwikManifest;
}) => PrefetchResource[]);

// @public (undocumented)
export const versions: {
    readonly qwik: string;
    readonly qwikDom: string;
};

// (No @packageDocumentation comment for this package)

```
